#
# SHIELD BLOCKED DAMAGE COUNS
#
scoreboard players set @a[team=!class_bknight] bk_shield_block 0
scoreboard players add @a[team=class_bknight,scores={bk_shield_block=1..}] bk_shield_count 1
execute if entity @a[team=class_bknight,scores={bk_shield_block=1..}] run function classes:class_bknight/shield_anim
scoreboard players set @a[team=class_bknight,scores={bk_shield_block=1..}] bk_shield_block 0

#
# SHIELD COOLDOWN
#
execute if entity @a[scores={bk_shield_cd=1..}] run clear @a[scores={bk_shield_cd=2..}] shield{Tags:["bk_shield"]}
scoreboard players remove @a[scores={bk_shield_cd=1..}] bk_shield_cd 1
title @a[scores={bk_shield_cd=1..}] actionbar ["",{"text":"§eShield Cooldown: §c"},{"score":{"name":"*","objective":"bk_shield_cd"}}]
replaceitem entity @a[team=class_bknight,scores={bk_shield_cd=1}] weapon.offhand shield{Damage:0,Tags:["bk_shield"]}

#
# SHIELD ONLY SECOND HAND
#
execute if entity @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{Slot:-106b,tag:{Tags:[bk_shield]}}]},scores={bk_shield_cd=0}] run clear @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{Slot:-106b,tag:{Tags:[bk_shield]}}]},scores={bk_shield_cd=0}] shield
execute if entity @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{Slot:-106b,tag:{Tags:[bk_shield]}}]},scores={bk_shield_cd=0}] run replaceitem entity @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{Slot:-106b,tag:{Tags:[bk_shield]}}]},scores={bk_shield_cd=0}] weapon.offhand shield{Tags:["bk_shield","und"]}

#
# ANTI LOSE SPEAR
#
execute if entity @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{tag:{Tags:["bk_spear"]}}]}] run give @a[tag=ingame,team=class_bknight,nbt=!{Inventory:[{tag:{Tags:["bk_spear"]}}]}] minecraft:wooden_shovel{display:{Name:"{\"text\":\"Spear\",\"italic\":\"false\"}"},HideFlags:63,Unbreakable:1b,Enchantments:[{id:"minecraft:sharpness",lvl:3}],Tags:[bk_spear,und]} 1

# EFFECT
effect give @a[team=class_bknight,tag=ingame] minecraft:slowness 1 0 true

#
# NOVA EFFECT
#
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run effect give @a[distance=0.05..15] minecraft:instant_damage 1 1
execute unless score @a[team=class_bknight,limit=1] bk_shield_cd matches 1.. run title @a[team=class_bknight,tag=ingame] actionbar ["",{"text":"§eShield Charge Level: §c"},{"score":{"name":"*","objective":"bk_shield_count"}},{"text":"§e/§c10"}]
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run particle minecraft:poof ~ ~0.5 ~ 10 0 10 0.5 50 normal
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run particle minecraft:instant_effect ~ ~0.5 ~ 10 0 10 0.5 50 normal
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run particle minecraft:explosion_emitter ~ ~0.5 ~ 0 0 0 0 1 normal
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run playsound minecraft:item.shield.block master @a ~ ~ ~ 10 0
execute at @a[team=class_bknight,scores={bk_shield_count=10..}] run playsound minecraft:entity.blaze.hurt master @a ~ ~ ~ 10 0
execute as @a[team=class_bknight,scores={bk_shield_count=10..}] at @s run execute as @a[distance=0.05..15] at @s run execute if block ^ ^ ^-1 air run execute if block ^ ^1 ^-1 air run tp @s ^ ^ ^-1
execute as @a[team=class_bknight,scores={bk_shield_count=10..}] at @s run execute as @a[distance=0.05..15] at @s run execute if block ^ ^ ^-1 air run execute if block ^ ^1 ^-1 air run tp @s ^ ^ ^-1
execute as @a[team=class_bknight,scores={bk_shield_count=10..}] at @s run execute as @a[distance=0.05..15] at @s run execute if block ^ ^ ^-1 air run execute if block ^ ^1 ^-1 air run tp @s ^ ^ ^-1
execute as @a[team=class_bknight,scores={bk_shield_count=10..}] at @s run execute as @a[distance=0.05..15] at @s run execute if block ^ ^ ^-1 air run execute if block ^ ^1 ^-1 air run tp @s ^ ^ ^-1
execute as @a[team=class_bknight,scores={bk_shield_count=10..}] at @s run execute as @a[distance=0.05..15] at @s run execute if block ^ ^ ^-1 air run execute if block ^ ^1 ^-1 air run tp @s ^ ^ ^-1
scoreboard players set @a[team=class_bknight,scores={bk_shield_count=10..}] bk_shield_count 0

#
# HORSE SPAWN
#
execute as @e[type=item,nbt={Item:{tag:{Tags:["bk_horse_spawn"]}}}] at @s run tp @e[tag=bk_horse,distance=..2] ~ ~-100 ~
execute as @e[type=item,nbt={Item:{tag:{Tags:["bk_horse_spawn"]}}}] at @s run summon horse ~ ~ ~ {Health:40f,Age:0,Tame:1b,Variant:256,Tags:["bk_horse","bk_horse_temp"],CustomName:"{\"text\":\"Royal Horse\",\"italic\":\"false\"}",Attributes:[{Name:generic.maxHealth,Base:40},{Name:generic.movementSpeed,Base:0.4}],SaddleItem:{id:"minecraft:saddle",Count:1b}}
execute as @e[type=item,nbt={Item:{tag:{Tags:["bk_horse_spawn"]}}}] at @s run tellraw @p "§aYou have spawned the Royal Horse, it'll despawn in 60s!"
kill @e[type=item,nbt={Item:{tag:{Tags:["bk_horse_spawn"]}}}]

# Horse Life
scoreboard players set @e[tag=bk_horse_temp] bk_horse_life 21
scoreboard players set @e[tag=bk_horse_temp] bk_horse_life_s 60

scoreboard players remove @e[scores={bk_horse_life=1..}] bk_horse_life 1

scoreboard players remove @e[scores={bk_horse_life=1}] bk_horse_life_s 1
scoreboard players set @e[scores={bk_horse_life=1}] bk_horse_life 21

execute as @e[scores={bk_horse_life_s=60}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(60s)\"}"}
execute as @e[scores={bk_horse_life_s=59}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(59s)\"}"}
execute as @e[scores={bk_horse_life_s=58}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(58s)\"}"}
execute as @e[scores={bk_horse_life_s=57}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(57s)\"}"}
execute as @e[scores={bk_horse_life_s=56}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(56s)\"}"}
execute as @e[scores={bk_horse_life_s=55}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(55s)\"}"}
execute as @e[scores={bk_horse_life_s=54}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(54s)\"}"}
execute as @e[scores={bk_horse_life_s=53}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(53s)\"}"}
execute as @e[scores={bk_horse_life_s=52}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(52s)\"}"}
execute as @e[scores={bk_horse_life_s=51}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(51s)\"}"}
execute as @e[scores={bk_horse_life_s=50}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(50s)\"}"}
execute as @e[scores={bk_horse_life_s=49}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(49s)\"}"}
execute as @e[scores={bk_horse_life_s=48}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(48s)\"}"}
execute as @e[scores={bk_horse_life_s=47}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(47s)\"}"}
execute as @e[scores={bk_horse_life_s=46}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(46s)\"}"}
execute as @e[scores={bk_horse_life_s=45}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(45s)\"}"}
execute as @e[scores={bk_horse_life_s=44}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(44s)\"}"}
execute as @e[scores={bk_horse_life_s=43}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(43s)\"}"}
execute as @e[scores={bk_horse_life_s=42}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(42s)\"}"}
execute as @e[scores={bk_horse_life_s=41}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(41s)\"}"}
execute as @e[scores={bk_horse_life_s=40}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(40s)\"}"}
execute as @e[scores={bk_horse_life_s=39}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(39s)\"}"}
execute as @e[scores={bk_horse_life_s=38}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(38s)\"}"}
execute as @e[scores={bk_horse_life_s=37}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(37s)\"}"}
execute as @e[scores={bk_horse_life_s=36}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(36s)\"}"}
execute as @e[scores={bk_horse_life_s=35}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(35s)\"}"}
execute as @e[scores={bk_horse_life_s=34}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(34s)\"}"}
execute as @e[scores={bk_horse_life_s=33}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(33s)\"}"}
execute as @e[scores={bk_horse_life_s=32}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(32s)\"}"}
execute as @e[scores={bk_horse_life_s=31}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(31s)\"}"}
execute as @e[scores={bk_horse_life_s=30}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(30s)\"}"}
execute as @e[scores={bk_horse_life_s=29}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(29s)\"}"}
execute as @e[scores={bk_horse_life_s=28}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(28s)\"}"}
execute as @e[scores={bk_horse_life_s=27}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(27s)\"}"}
execute as @e[scores={bk_horse_life_s=26}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(26s)\"}"}
execute as @e[scores={bk_horse_life_s=25}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(25s)\"}"}
execute as @e[scores={bk_horse_life_s=24}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(24s)\"}"}
execute as @e[scores={bk_horse_life_s=23}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(23s)\"}"}
execute as @e[scores={bk_horse_life_s=22}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(22s)\"}"}
execute as @e[scores={bk_horse_life_s=21}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(21s)\"}"}
execute as @e[scores={bk_horse_life_s=20}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(20s)\"}"}
execute as @e[scores={bk_horse_life_s=19}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(19s)\"}"}
execute as @e[scores={bk_horse_life_s=18}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(18s)\"}"}
execute as @e[scores={bk_horse_life_s=17}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(17s)\"}"}
execute as @e[scores={bk_horse_life_s=16}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(16s)\"}"}
execute as @e[scores={bk_horse_life_s=15}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(15s)\"}"}
execute as @e[scores={bk_horse_life_s=14}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(14s)\"}"}
execute as @e[scores={bk_horse_life_s=13}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(13s)\"}"}
execute as @e[scores={bk_horse_life_s=12}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(12s)\"}"}
execute as @e[scores={bk_horse_life_s=11}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(11s)\"}"}
execute as @e[scores={bk_horse_life_s=10}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(10s)\"}"}
execute as @e[scores={bk_horse_life_s=9}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(9s)\"}"}
execute as @e[scores={bk_horse_life_s=8}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(8s)\"}"}
execute as @e[scores={bk_horse_life_s=7}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(7s)\"}"}
execute as @e[scores={bk_horse_life_s=6}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(6s)\"}"}
execute as @e[scores={bk_horse_life_s=5}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(5s)\"}"}
execute as @e[scores={bk_horse_life_s=4}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(4s)\"}"}
execute as @e[scores={bk_horse_life_s=3}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(3s)\"}"}
execute as @e[scores={bk_horse_life_s=2}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(2s)\"}"}
execute as @e[scores={bk_horse_life_s=1}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(1s)\"}"}
execute as @e[scores={bk_horse_life_s=0}] run data merge entity @s {CustomName:"{\"text\":\"Royal Horse §c(0s)\"}"}

kill @e[scores={bk_horse_life_s=..0}]
tag @e[tag=bk_horse_temp] remove bk_horse_temp
